/*
	will hide html elemens with class="help-item-sectionname"

	where sectionname is one of the passed to the help page as ?disabled_help_items=section1,section2,section3
*/
(function () {
    document.addEventListener('DOMContentLoaded', function () {
        disable_nodes();
    });

    function disable_nodes() {
        var parsedQuery = getAllQueryString();
        var itemsToDisable = parsedQuery["disabled_help_items"];
        if (typeof itemsToDisable !== "undefined") {
            var itemsToDisableList = itemsToDisable.split(",");
            for(var i = 0; i < itemsToDisableList.length; i++) {
                var name = itemsToDisableList[i];
                var nodes = document.getElementsByClassName("help-item-" + name);
                for(var j = 0; j < nodes.length; j++) {
                    nodes[j].style.display = "none";
                }
            }
        }
    }

    function getAllQueryString() {
        var url = location.href;
        var result = {};
        if (url.indexOf('?') >= 0) {
            var qs = url.substring(url.indexOf('?') + 1).split('&');
            for(var i = 0; i < qs.length; i++) {
                qs[i] = qs[i].split('=');
                var key = qs[i][0];
                result[key] = decodeURIComponent(qs[i][1]);
            }
        }

        return result;
    }

})();