/*
    TODO list:
        lets rename global variable to be with g_ prefix and with _ will be constants
        add comments cross code to make more understandable
        isPopup / popup - not very meaningfull, lets rename according to semantic
*/
var g_widgetId;         // unique id communicated by Client via ClassId=100 during initalization
var g_languageCode;     // languageCode communicated by Client via ClassId=100 during initalization

var g_JackpotConfig;
var winJackpot = {};
var widthPage;
var heightPage;
var isPopup;
var minigameEndClient;
var soundCoinMoveSRC = "../../resources/sounds/aotg_minigame/coin_move.mp3";
var soundWinningJackpot = "../../resources/sounds/aotg_minigame/winning_jackpot.mp3";
var soundExplosionJackpot = "../../resources/sounds/aotg_minigame/explosion_jackpot.mp3";
var soundCoinsWinJackpot = "../../resources/sounds/aotg_minigame/coins_win_jackpot.mp3";
var prizesPositions = [];
var isWonJackpot = false;
var isAutoPlay = false;
var _COIN_SHOW = 500;
var _POPUP_CONT_SHOW = 3500;
var _SHOW_FINAL_SCREEN_TIME = 5000;
var _SHOW_FINAL_ANIM_SCREEN_TIME = 5000;
var timeS;
var translations;
var audio;
var connection = new PostMessageConnection.PostMessageConnection(window, window.parent, this);

// also string should be like '{@username} is playing for a jackpot', '{@username} won {@wonAmount}' etc
// support clients which don't send yet the jackpots yet
var _PRIZES = [
    _ULTIMATE_POWER = {
        id: "4",
        name: "UltimatePower",
        prizeClick: 0,
        currency: "",
        amount: ""
    },
    _SUPER_POWER = {
        id: "3",
        name: "SuperPower",
        prizeClick: 0,
        currency: "",
        amount: ""
    },
    _EXTRA_POWER = {
        id: "2",
        name: "ExtraPower",
        prizeClick: 0,
        currency: "",
        amount: ""
    },
    _POWER = {
        id: "1",
        name: "Power",
        prizeClick: 0,
        currency: "",
        amount: ""
    }]
var prizesCount = _PRIZES.length;

function sendPostMessage(data) {
    data.widgetId = g_widgetId;
    var sMessage = JSON.stringify(data);
    console.log("Animation: sending message to Client:", sMessage);
    connection.sendMessage(sMessage);
}

function sendAOTGMinigameEndEvent() {
    sendPostMessage({classId: 404})
}

function PokerClientAOTGStartWonAnimationResponse() {
    sendPostMessage({classId: 406})
}

function sendAOTGWonAnimationEndEvent() {
    sendPostMessage({classId: 405})
}

function adjustScale(w, h) {
    var scaleWidth = window.innerWidth / w;
    var scaleHeight = window.innerHeight / h;
    var scale = Math.min(scaleWidth, scaleHeight);

    if ((window.innerWidth < w) || (window.innerHeight < h) || (isPopup)) {
        $("body").css({
            "zoom": scale,
            "-ms-transform": "scale(" + scale + ")",
            "-moz-transform": "scale(" + scale + ")"
        });
    }
}

function setPreferences(data) {
    if (data.languageCode) {
        g_languageCode = data.languageCode;
    }
    if (typeof data.soundLevel !== "undefined") {
        audio.volume = data.soundLevel;
    }
}

function getCurrency(c) {
    c = c.replace('€' && 'EUR', '&euro;');
    c = c.replace('$' && 'USD', '&#36;');
    c = c.replace('£' && 'GBP', '&pound;');
    c = c.replace('¥' && 'JPY', '&yen;');
    return c;
}

function formatAmount(a) {
    return a = (a % 1 != 0 ? a.toFixed(2) : a).toString().replace(/\B(?=(\d{3})+(?!\d))/g, ",");
}

function onMessage(jsObject) {
    try {
        console.log("Animation: got message from Client:", jsObject);
        switch (jsObject.classId) {
            case 100:
                if (jsObject.widgetId) {
                    g_widgetId = jsObject.widgetId;
                }
                setPreferences(jsObject);
                Translations.default.loadTranslationsByLangString(g_languageCode).then(function(instance) {
                    translations = instance;
                    // "client" is informing page that it's ready and can accept post message notifications
                    // "page" is informing "client" that it's also ready
                    window.sendPostMessage({ "classId": 3, "pageName": "AOG Animation Mini/Won", "pageVersion": "1.0" });
                });
                break;
            case 106:
                setPreferences(jsObject);
                break;
            case 402: // start mini game
                g_JackpotConfig = jsObject;
                g_JackpotConfig.winAmount = formatAmount(g_JackpotConfig.winAmount);
                g_JackpotConfig.currency = getCurrency(g_JackpotConfig.currency);
                if (g_JackpotConfig.isWinner) {
                    for (var i = 0; i < prizesCount; i++) {
                        if (g_JackpotConfig.jackpots !== undefined) {
                            for (var j = 0; j < g_JackpotConfig.jackpots.length; j++) {
                                if (_PRIZES[i].id == g_JackpotConfig.jackpots[j].type) {
                                    _PRIZES[i].amount = formatAmount(g_JackpotConfig.jackpots[j].amount);
                                    _PRIZES[i].currency = getCurrency(g_JackpotConfig.jackpots[j].currency);
                                }
                            }
                        }
                        if (_PRIZES[i].id === g_JackpotConfig.jackpotType) {
                            _PRIZES[i].amount = g_JackpotConfig.winAmount;
                            _PRIZES[i].currency = g_JackpotConfig.currency;
                            winJackpot = _PRIZES[i];
                        }
                    }
                    timeS = Math.floor((parseInt(g_JackpotConfig.timeTillGameplayStartMs) - _SHOW_FINAL_SCREEN_TIME - _SHOW_FINAL_ANIM_SCREEN_TIME) / 1000);
                    minigame.init();
                } else {
                    $("html").removeClass("minigame").addClass("popup");
                    minigameEndClient = false;
                    popup.init();
                }
                //adjustScale(widthPage, heightPage);
                break;
            case 403: // start won animation
                minigameEndClient = true;
                widthPage = 384;
                heightPage = 224;
                adjustScale(widthPage, heightPage);
                $("html").addClass("popup");
                $("#popup").addClass("minigameEnd");
                popup.init();
                break;
            default:
                console.log("Animation: received message, but no handler found, classId=" + jsObject.classId);
                break;
        }
    } catch (e) {
        console.error(e);
    }
}

$(window).resize(function () {
    adjustScale(widthPage, heightPage)
})
$(window).on('load', function() {
    audio = new Audio.Audio();
    connection.connect();
    document.addEventListener('touchmove', function(e) {
        e.preventDefault();
    });
});

//private methods should be prefixed with _
var minigame = {
    buildCoinsMatrix: function () {
        _coinContainer = $(".coin_container");
        var _COINS = [];
        var _COINS_COUNT = 20;
        var prizesOfType = _COINS_COUNT / prizesCount;
        for (var x = 0; x < prizesCount; x++) {
            for (var y = 0; y < prizesOfType; y++) {
                _COINS.push(_PRIZES[x].name);
            }
        }

        _COINS.sort(function () {
            return Math.random() - Math.random()
        });
        for (var i = 0; i < _COINS_COUNT; i++) {
            _coinContainer.append('<div class="coin_wrapper" data-prize="' + _COINS[i] + '" id="coin' + (i + 1) + '"><div class="coin" data-id="' + i + '"><div class="sparkle1"></div><div class="sparkle2"></div><div class="sparkle3"></div></div></div>');
        }
    },
    buildPrizes: function () {
        for (var i = 0; i < prizesCount; i++) {
            $(".prizes").append('<div class="prizes' + _PRIZES[i].name + '" id="' + _PRIZES[i].name + '"><div class="prize_header"></div><div class="prize_field"><p>' + _PRIZES[i].currency + _PRIZES[i].amount + '</p></div><div class="indicators"><div class="indicator inactive"></div><div class="indicator inactive"></div><div class="indicator inactive"></div></div></div>')
        }
    },
    // TODO: this function could have better name with some semantic
    loadContent: function () {
        $(".winTxt").attr("data-text", translations.getText("aog_you_won")).append(translations.getText("aog_you_won"));
        $(".txt_instruction").append(translations.getText("aog_instruction"));
        $(".txt_autoplay").append(translations.getText("aog_autoplay"));
    },
    countdown: function () {
        if (timeS < 10) {
            $(".seconds").html('0' + timeS);
        } else {
            $(".seconds").html(timeS);
        }
    },
    refreshTimer: function () {
        var _this = this;
        this.countdown();
        timerFunction = setInterval(function () {
            timeS = parseInt($(".seconds").html());
            timeS = timeS - 1;
            if (timeS > 0) {
                _this.countdown();
            }
            if (timeS === 0) {
                _this.countdown();
                isWonJackpot = true;
                isAutoPlay = true;
                $("#" + winJackpot.name + " .inactive").each(function () {
                    $(this).removeClass("inactive").addClass("active");
                    $(this).append('<div class="indExplosion"></div>');
                })
                _this.jackpotWin();
            }

        }, 1000)

    },
    disableCoins: function () {
        $(".coin_wrapper").each(function () {
            var coinType = $(this).attr('data-prize');
            if (isAutoPlay) {
                if (coinType !== winJackpot.name) {
                    if (!($(this).hasClass("isClicked"))) {
                        $(this).addClass("disabled").append('<div class="shine"></div><div class="coin_opened"><div class="logo"></div></div>');
                    } else {
                        $(this).addClass("disabled");
                    }
                } else if (!($(this).hasClass("isClicked"))) {
                    $(this).addClass("isClicked").append('<div class="shine"></div><div class="coin_opened"><div class="logo"></div></div>');
                }
            } else if (!($(this).hasClass("isClicked"))) {
                $(this).addClass("disabled").append('<div class="shine"></div><div class="coin_opened"><div class="logo"></div></div>');
                $(this).find(".coin").remove();
            } else if (coinType !== winJackpot.name) {
                $(this).addClass("disabled");
            }
            $(this).find(".coin").remove();
        })
    },
    isPlaying: function () {
        $(".coin").on('click', function () {
            prizesPositions = [];
            audio.play(soundCoinMoveSRC);
            var currentCoinPrize = $(this).parent().attr("data-prize");
            for (var i = 0; i < prizesCount; i++) {
                if (_PRIZES[i].name === currentCoinPrize) {
                    var prizeType = _PRIZES[i];
                }
            }

            if ((prizeType.prizeClick < 2) && (prizeType.name !== winJackpot.name)) {
                prizeType.prizeClick++;
            } else {
                winJackpot.prizeClick++;
                currentCoinPrize = winJackpot.name;
                $(this).parent().attr("data-prize", currentCoinPrize);
                if (winJackpot.prizeClick === 3) {
                    isWonJackpot = true;
                    $(".coin").off("click");
                }
            }

            var prizePanel = $("#" + currentCoinPrize + " .inactive").first();
            prizesPositions.push(prizePanel.offset());
            var coinPos = $(this).offset();
            $(this).css({
                'position': 'fixed',
                'top': coinPos.top,
                'left': coinPos.left
            });
            $(this).parent().addClass("isClicked").append('<div class="shine"></div><div class="coin_opened"><div class="logo"></div></div>');
            prizePanel.append('<div class="indExplosion"></div>');
            prizePanel.removeClass("inactive").addClass("active");
            $(this).addClass("flip");
            $(this).animate({
                top: prizesPositions[0].top,
                left: prizesPositions[0].left

            }, 500, function(){
                if (isWonJackpot) {
                    minigame.jackpotWin();
                }
            });

        });

    },
    jackpotWin: function () {
        clearInterval(timerFunction);
        audio.play(soundWinningJackpot);
        this.disableCoins();
        $(".winScreen").addClass("win" + winJackpot.name + "");
        $(".amount").html("<p data-text="+ winJackpot.currency + winJackpot.amount +">"+ winJackpot.currency + winJackpot.amount + "</p>");
        $(".txt_messages *").remove();
        $(".txt_messages").append("<div class='congrat_text'>" + translations.getText("aog_congratulations") + "</div>");
        coinZoomAnimTime = 2000;
        var coinsWin = $(".isClicked[data-prize=" + winJackpot.name + "] .coin_opened");
        var centerY = (_coinContainer.offset().top) + (_coinContainer.height() / 2);
        var centerX = (_coinContainer.offset().left) + (_coinContainer.width() / 2);
        $("#" + winJackpot.name + "").addClass("animWinPrize");
        var coinsWinPos = [];
        coinsWin.each(function () {
            coinsWinPos = [];
            coinsWinPos.push($(this).offset());
            $(this).css({
                'animation-duration':  coinZoomAnimTime + 'ms',
                '-webkit-animation-duration':  coinZoomAnimTime + 'ms',
                'position': 'fixed',
                'z-index': 8,
                'top': coinsWinPos[0].top,
                'left': coinsWinPos[0].left
            });
            $(this).addClass('coinZoom');
        });
        setTimeout(function () {
            audio.play(soundExplosionJackpot);
            $(".maskScreen").addClass("animMask");
            $(".coin_container").append('<div class="explosion"></div>');
            // if (!isAutoPlay) {
                coinsWin.animate({
                    top: centerY - (coinsWin.height() / 2),
                    left: centerX - (coinsWin.width() / 2)
                }, 300);
                coinsWin.animate({
                    opacity: 0
                }, 100, "linear");
            // }
            $("#" + winJackpot.name + " .prize_field").html("<p data-text="+ winJackpot.currency + winJackpot.amount +">"+ winJackpot.currency + winJackpot.amount + "</p>");
        }, coinZoomAnimTime);

        setTimeout(function () {
            sendAOTGMinigameEndEvent();
            isPopup = true;
            widthPage = 384;
            heightPage = 224;
            adjustScale(widthPage, heightPage);
            $("html").removeClass("minigame").addClass("popup");
        }, _SHOW_FINAL_SCREEN_TIME)

    },
    init: function () {
        widthPage = 960;
        heightPage = 600;
        isPopup = false;
        $("html").removeClass("popup").addClass("minigame");
        adjustScale(widthPage, heightPage);
        this.buildCoinsMatrix();
        this.buildPrizes();
        this.loadContent();
        this.refreshTimer();
        this.isPlaying();
    }
}

var popup = {
    loadContent: function () {
        $(".user p").empty().append(g_JackpotConfig.winningPlayer).attr("data-text", g_JackpotConfig.winningPlayer);
        if (minigameEndClient) {
            $("body").removeClass("informMessage").addClass("minigameEnd");
            $(".popup_coin").css("display","none");
            audio.play(soundCoinsWinJackpot);
            $(".txtWon p").empty().append(translations.getText("aog_won")).attr("data-text", translations.getText("aog_won"));
            $(".txt_content p").empty();
            $(".txt_content").html("<p data-text="+ g_JackpotConfig.currency + g_JackpotConfig.winAmount +">"+ g_JackpotConfig.currency + g_JackpotConfig.winAmount + "</p>")
            setTimeout(function () {
                sendAOTGWonAnimationEndEvent();
            }, _SHOW_FINAL_ANIM_SCREEN_TIME)
        } else {
            $("body").removeClass("minigameEnd").addClass("informMessage");
            $(".txt_content p").empty().append(translations.getText("aog_playing_for_jackpot")).attr("data-text", translations.getText("aog_playing_for_jackpot"));
        }
    },
    animTimes: function () {
        if (!minigameEndClient) {
            $("body").removeClass("minigameEnd").addClass("informMessage");
            setTimeout(function () {
                $(".popup_coin").append('<div class="sparkle1"></div><div class="sparkle2"></div><div class="sparkle3"></div>');
            }, _COIN_SHOW + _POPUP_CONT_SHOW);
        }
    },
    init: function () {
        widthPage = 384;
        heightPage = 224;
        $("html").removeClass("minigame").addClass("popup");
        isPopup = true;
        adjustScale(widthPage, heightPage);
        this.loadContent();
        this.animTimes();
		if (minigameEndClient) {
            PokerClientAOTGStartWonAnimationResponse();
        }
    }
}
