function TestClass(url) {

    this.username = $.urlParam("username");
    this.temptoken = $.urlParam("temptoken");

    this.test = new Test(url, document.body, 100, null, 0, 200, { skipIntegrationMessage:true });
    this.test.initPostMessage(this);
    this.test.hideWidget(); // by default chat is hidden

    this.onMessage = function (message) {
        switch (message.classId) {
            case 60110:
                this.test.sendMessage({classId: 60111, requestId: message.requestId, errorCode: 0, urlsList:
                        [
                            {urlType: "imschat_instance_name", url: "playtechhorizon_PT_ICE_2018"},
                            {urlType: "imschat_server_address", url: "https://chat.playtechone.com/chat_web"}
                        ]

                    /*
                    [
                        {urlType: "imschat_instance_name", url: "playtech830012_Testing_Chat_API_v2_for_QTMOB"},
                        {urlType: "imschat_server_address", url: "http://10.145.97.27:8080/chat_web"}
                    ]
                    */
                });
                break;
            case 60185:
                this.test.sendMessage(
                    {
                        classId: 60186,
                        token: this.temptoken,
                        serviceType: message.serviceType,
                        systemId: message.systemId
                    }
                );
        }
    },

    this.onIntegrationMessage = function (message) {
        switch (message.classId) {
            case 501:
                console.log(new Date() + " INFO [Client simulator] - Got unread counter: ", message);
                this.htmlLog(JSON.stringify(message));
                this.htmlLog('Unread messages:' + message.count);
                $('#unreadMessagesCounter').html(message.count);
                break;
            default:
                console.log(new Date() + " INFO [Client simulator] - Not found integration message process block", message);
                break;
        }
    },

    this.sendInitMessage = function (){
        this.test.sendIntegrationMessage({classId: 100, languageCode: "EN", soundLevel: 1.0, username: this.username}, "*");
    },

    this.sendChangeLanguage = function (langCode) {
        this.test.sendIntegrationMessage({
                classId: 106,
                languageCode: langCode
            }
        )
    }

    this.htmlLog = function(s) {
        $('#htmlLog').append(s + '<br/>');
        $('#htmlLog').scrollTop($('#htmlLog').prop("scrollHeight"));
    }

}
