var _postTarget = window.location.protocol + '//' + window.location.hostname + ':' + window.location.port;

function SaWTest(url) {

    var randomRewardTicketsResponse;
    var transactionCodes = {};
    var increment = 0;

    var test = new Test(url, document.body, 100, 100, 0, "10", null, "static");
    test.initPostMessage(this);

    this.onMessage = function (message) {
        switch (message.classId) {
            case 60240:
                setTimeout(function() {
                    this.sendPools("proto/rr_pools_new.json");
                }.bind(this), 1500);
                break;
            case 60242:
                this.sendTickets("proto/rr_tickets_new.json");
                break;
            case 60245:
                $.getJSON("proto/rr_pools_new.json", function (data) {
                    var prizeCode;
                    for (var i = 0; i < data.pools.length; i++) {
                        var pool = data.pools[i];
                        if (pool.code === message.templateCode) {
                            prizeCode = pool.rewards[0].code;
                        }
                    }
                    increment++;
                    transactionCodes[increment] = message.templateCode;
                    test.sendMessage({ classId: 60246, requestId: message.requestId, prizeCode: prizeCode, transactionCode: increment });
                }.bind(this));
                break;
            case 60247:
                var templateCode = transactionCodes[message.transactionCode];
                if (templateCode) {
                    transactionCodes[message.transactionCode] = null;
                    randomRewardTicketsResponse.totalTickets = randomRewardTicketsResponse.totalTickets - 1;
                    for (var i = 0; i < randomRewardTicketsResponse.tickets.length; i++) {
                        var ticket = randomRewardTicketsResponse.tickets[i];
                        if (ticket.templateCode === templateCode) {
                            ticket.totalCount = ticket.totalCount - 1;
                        }
                    }
                    test.sendMessage(randomRewardTicketsResponse);
                }
                break;
            case 60110:
                test.sendMessage({classId: 60111, requestId: message.requestId, errorCode: 0, urlsList: [{urlType: "URLID_random_reward_tc", url: "http://www.google.com"}]});
                break;
        }
    }

    this.onIntegrationMessage = function (message) {
        switch (message.classId) {
            case 104:
                console.log(new Date() + " INFO [Client simulator] - Asked open URL: ", message);
                window.open(message.url);
                break;
            default:
                console.log(new Date() + " INFO [Client simulator] - Not found integration message process block", message);
                break;
        }
    }

    this.sendPools = function (fileName) {
        test.sendJsonFile(fileName);
    }

    this.sendClearPools = function () {
        test.sendMessage({ classId: 60241, pools: [] });
    }

    this.sendTickets = function (fileName) {
        $.getJSON(fileName, function (data) {
            randomRewardTicketsResponse = data;
            test.sendMessage(data);
        }.bind(this));
    }

    this.sendClearTickets = function () {
        ticketsData = null;
        test.sendMessage({ classId: 60243, tickets: [], totalTickets: 0 });
    }

    this.setSoundLevel = function (soundLevel) {
        test.sendIntegrationMessage({classId: 106, soundLevel: soundLevel});
    }

    this.sendShowPool = function (templateCode, triggerOrigin) {
        test.sendIntegrationMessage({ classId: 301, templateCode: templateCode, triggerOrigin: triggerOrigin }, _postTarget);
    }

    this.triggerOrigin = function (triggerOrigin) {
        test.sendIntegrationMessage({ classId: 301, triggerOrigin: triggerOrigin }, _postTarget);
    }

    this.sendSortPools = function (by) {
        test.sendIntegrationMessage({ classId: 301, orderPoolsBy: by }, _postTarget);
    }

    this.sendChangeLanguage = function (langCode) {
        test.sendIntegrationMessage({
                classId: 106,
                languageCode: langCode
            }
        )
    }

}
